#!/bin/sh
set -x
if [ $# -ne 1 ]; then
	echo usage: $0 ucd-snmp-src-dir
	echo Copies files needed for PODUNK-RR-MIB demo to proper subdirectories of ucd-snmp-src-dir
	exit 1
fi

if [ ! -d $1 ]; then
	echo usage: $0 ucd-snmp-src-dir
	echo Destination directory $1 not found
	exit 1
fi

DEST=$1/agent/mibgroup
if [ ! -d $DEST ]; then
	echo usage: $0 ucd-snmp-src-dir
	echo Destination subdirectory $DEST not found
	exit 1
fi

FILES="\
	dprint.c \
	dprint.h \
	fsubagent.c \
	fsubagent.h \
	fsubagentArray.c \
	fsubagentArray.h \
	fsubagentArray2.c \
	fsubagentArray2.h \
	fsubagentRow.c \
	fsubagentRow.h \
	fsubagent_utils.c \
	fsubagent_utils.h \
	podunk_rr.c \
	podunk_rr.h \
	podunk_rr_mib.h \
	portable.h"

cp $FILES $DEST

DEST=$1/mibs
cp PODUNK-RR-MIB.txt $DEST

