/*--------------------------------------------------------------------------
 code to extend UCD-SNMP agent for DISAPPEARING-SNMP-MIB
 Compiled inside the ucd-snmp source tree 
--------------------------------------------------------------------------*/

#ifndef fsubagent_utils_H
#define fsubagent_utils_H

#include "fsubagent.h"

/* whoever includes this .h file must also include config.h and mibincl.h */

/* How long to cache data read from disk. */
extern int fsubagent_utils_cacheSeconds;

/* The object that grabs data from the file written by the monitored daemon */
extern fsubagent *fsubagent_utils_subagent;

/**
 * check currency of OID data and refresh if necessary
 * FIXME: uses a static variable
 */
void fsubagent_utils_update(int force);

/* Called by wrapper functions.
 * Check OID against given row, then get variable if appropriate. 
 */
unsigned char *
fsubagent_utils_getFromScalarRow(
	fsubagentRow		*row,
	struct variable *vp, 
	oid				*name, 
	size_t			*length, 
	int				exact, 
	size_t			*var_len, 
	WriteMethod	**write_method);

/* Called by wrapper functions.
 * Check OID against given 1-index table, then get variable if appropriate. 
 */
unsigned char *
fsubagent_utils_getFromTable1(
	fsubagentArray	*arr,
	struct variable *vp, 
	oid				*name, 
	size_t			*length, 
	int				exact, 
	size_t			*var_len, 
	WriteMethod	**write_method);

/* Called by wrapper functions.
 * Check OID against given 2-index table, then get variable if appropriate. 
 * More complicated because there's no 'header_simple_table2' routine.
 * See http://www.csc.liv.ac.uk/~daves/Misc/UCD/07-table2.html
 * and compare with header_simple_table() in util_funcs.c
 * and header_hrpartition() in ucd-snmp-4.2/agent/mibgroup/host/hr_partition.c
 * FIXME: this needs cleaning up!
 */
unsigned char *
fsubagent_utils_getFromTable2(
	fsubagentArray2	*arr2,
	struct variable *vp, 
	oid				*name, 
	size_t			*length, 
	int				exact, 
	size_t			*var_len, 
	WriteMethod	**write_method);

#endif
